@echo off
setlocal
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Run this file to update MiKTeX and R each time you upgrade R.
:: R and MiKTeX must have been previously installed.
:: R should have been installed with a registry entry.
:: The directory above the rw... directory, 
:: e.g. c:\program files\R 
:: should contain a folder called library and the *.site files.  
::
:: If you have multiple versions of R installed and don't want to
:: use the one that has the registry entry set you can either
:: (1) cd to the rw directory of the R version you want prior to
:: issuing this command or (2) define Rrw environment variable
:: to point to the version you want prior to issuing this command.
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

ver | findstr XP >NUL
if errorlevel 1 echo Warning: This script has only been tested on Windows XP.

:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: use environment variable Rrw if defined
:: else current folder if bin\rcmd.exe exists 
:: else most current R as determined by registry entry
:: else error
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
if not defined Rrw if exist bin\rcmd.exe set Rrw=%CD%
if not defined Rrw for /f "tokens=2*" %%a in (
 'reg query hklm\software\r-core\r /v InstallPath 2^>NUL ^| findstr InstallPath'
  ) do set Rrw=%%~sb
if not defined Rrw echo "Error: R not found" & goto:eof

if /i "%1"=="--no-miktex" goto:siteCopy

:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Find MiKTeX local root
:: ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
if not defined MiktexLocalRoot for /f "tokens=3*" %%a in (
 'reg query HKEY_LOCAL_MACHINE\SOFTWARE\MiK\MiKTeX\CurrentVersion\MiKTeX /v "Local Root" 2^>NUL ^| findstr Local'
  ) do set MiktexLocalRoot=%%~sb
if not defined MiktexLocalRoot echo "Error: localtexmf not found" & goto:eof

if not exist %MiktexLocalRoot%\tex md %MiktexLocalRoot%\tex
echo Copy .sty and .fd files from R to MiKTeX
copy %Rrw%\share\texmf\*.* %MiktexLocalRoot%\tex

echo Updating MiKTeX file name data base
initexmf -u
echo.
echo Finding Rd.sty
findtexmf Rd.sty
echo check last line that Rd.sty was found in localtexmf tex folder
:siteCopy
copy %Rrw%\..\*.site %Rrw%\etc

endlocal

