setlocal

set installargs=
set buildargs=
set checkargs=
set buildargs=--no-vignettes
set checkargs=--no-vignettes

:: Usage: makepkg check mypkg
:: or   : makepgk install mypkg
::    where mypkg is path to mypkg source
:: For install, package is installed in .\library
::
:: In both cases a .tar.gz file is built first.

set pkgsrc=%2
FOR /F "tokens=1,2" %%i in (%pkgsrc:/=\%\DESCRIPTION) do (
	if /i %%i==Version: set pkgversion=%%j
	if /i %%i==Package: set pkgname=%%j
)

set pkgversion
set pkgname

set "tarfile=%pkgname%_%pkgversion%.tar.gz"

if %1x == x ( 
	echo "Usage: makepkg install mypkg or makepkg check mypkg"
	goto:eof 
)


:: set R_LIBS
if defined R_LIBS goto:endRLib
	set odir=%CD%

	if not defined Rrw if exist bin\rcmd.exe set Rrw=%CD%
	if not defined Rrw for /f "tokens=2*" %%a in (
	 'reg query hklm\software\r-core\r /v InstallPath 2^>NUL ^| findstr InstallPath'
	) do set Rrw=%%~sb
	if not defined Rrw echo "Error: R not found" & goto:eof

	cd %Rrw%
	cd ..
	if exist library set R_LIBS=%CD%\library
	cd %odir%
)
:endRLib
cd

call :%1
goto:eof

:build
	call rcmd build %pkgsrc% %buildargs%
	goto:eof

:install
	call :build
	if not exist library md library
	:loop
		set bck=%pkgname%-%random%.bck
		if exist %bck% goto :loop
	if exist "%pkgname%" move library\%pkgname% %bck%
	cd
	dir %tarfile%
	call rcmd install %tarfile% -l library %installargs%
	goto:eof

:check
	call :build
	call rcmd check %tarfile% %checkargs%
	goto:eof

endlocal
